<script setup lang="ts">
import type { SequencePreview } from "~/utils/types/sequence";
const props = defineProps<SequencePreview & { text: string }>();
const padEvery = (str: string, numChar: number) => {
  if (!str) {
    return "";
  }
  const regex = new RegExp(`.{1,${numChar}}`, "g");
  return str.match(regex)?.join(" ");
};
const paddedFasta = computed(() => {
  return props.sequences
    .map((sequence) => {
      return `>${sequence.id}\n${padEvery(sequence.seq, 10)}`;
    })
    .join("\n");
});

const rawFasta = computed(() => {
  return props.sequences
    .map((sequence) => {
      return `>${sequence.id}\n${sequence.seq}`;
    })
    .join("\n");
});

const filename = computed(
  () => props.title.replace(" ", "_").toLowerCase() + ".fa",
);
</script>

<template>
  <v-dialog scrollable max-width="420px">
    <template #activator="{ props: dialogProps }">
      <span v-bind="dialogProps" class="text-primary" style="cursor: pointer">
        <span class="text-body-1">
          {{ props.text }}
        </span>
      </span>
    </template>
    <v-card>
      <v-card-title class="text-primary">{{ title }}</v-card-title>
      <v-card-text
        class="text-subtitle-2"
        style="max-height: 420px; white-space: pre-line"
        ><code>{{ paddedFasta }}</code></v-card-text
      >
      <v-card-actions>
        <CopyToClipboard :text="rawFasta" />
        <TextDownloader :text="rawFasta" :filename="filename" />
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>
